package my.com.connector.ws.client.dao;

import my.com.connector.ws.client.data.EventLog;

/**
 * The DAO for <code>EVENT_LOG</code> table.
 * 
 * @author chinyeh
 *
 */
public interface EventLogDao {

	/**
	 * @param eventLog the eventLog object to be persisted
	 * @return the persisted eventLog
	 */
	EventLog persist(EventLog eventLog);
	
	/**
	 * Updates the event status based on the given ID.
	 * 
	 * @param id the ID of the event
	 * @param eventStatus the event status
	 * @param errorMsg the error message if any
	 * @return the number of affected rows
	 */
	int updateEventById(int id, String eventStatus, String errorMsg);
}
