package my.com.connector.ws.client.data;

/**
 * Represents the asynchronous based web service request.
 * 
 * @author chinyeh
 * 
 * @param <E> the type of the request entity
 * @param <T> the type of the response entity
 */
public class AsyncWebServicesRequest<E, T> extends WebServicesRequest<E, T> {

	private String asyncWebServiceUrl;
	
	private String callbackUrl;
	
	private String eventLogId;
	
	private String mallIndicator;
	
	private String trxType;
	
	private String clientTrxId;

	/**
	 * @param asyncWebServiceUrl the URL of the asynchronous web service
	 * @param requestEntity the request entity
	 * @param responseType the type of the response
	 */
	public AsyncWebServicesRequest(String asyncWebServiceUrl,
			E requestEntity, Class<T> responseType) {
		super(requestEntity, responseType);
		this.asyncWebServiceUrl = asyncWebServiceUrl;
	}
	
	/**
	 * @return the callbackUrl
	 */
	public String getCallbackUrl() {
		return callbackUrl;
	}

	/**
	 * @return the eventLogId
	 */
	public String getEventLogId() {
		return eventLogId;
	}

	/**
	 * @param callbackUrl the callbackUrl to set
	 */
	public void setCallbackUrl(String callbackUrl) {
		this.callbackUrl = callbackUrl;
	}

	/**
	 * @param eventLogId the eventLogId to set
	 */
	public void setEventLogId(String eventLogId) {
		this.eventLogId = eventLogId;
	}

	/**
	 * @return the asyncWebServiceUrl
	 */
	public String getAsyncWebServiceUrl() {
		return asyncWebServiceUrl;
	}

	/**
	 * @param asyncWebServiceUrl the asyncWebServiceUrl to set
	 */
	public void setAsyncWebServiceUrl(String asyncWebServiceUrl) {
		this.asyncWebServiceUrl = asyncWebServiceUrl;
	}

	/**
	 * @return the mallIndicator
	 */
	public String getMallIndicator() {
		return mallIndicator;
	}

	/**
	 * @return the trxType
	 */
	public String getTrxType() {
		return trxType;
	}

	/**
	 * @return the clientTrxId
	 */
	public String getClientTrxId() {
		return clientTrxId;
	}

	/**
	 * @param mallIndicator the mallIndicator to set
	 */
	public void setMallIndicator(String mallIndicator) {
		this.mallIndicator = mallIndicator;
	}

	/**
	 * @param trxType the trxType to set
	 */
	public void setTrxType(String trxType) {
		this.trxType = trxType;
	}

	/**
	 * @param clientTrxId the clientTrxId to set
	 */
	public void setClientTrxId(String clientTrxId) {
		this.clientTrxId = clientTrxId;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("AsyncWebServicesRequest [asyncWebServiceUrl=");
		builder.append(asyncWebServiceUrl);
		builder.append(", callbackUrl=");
		builder.append(callbackUrl);
		builder.append(", clientTrxId=");
		builder.append(clientTrxId);
		builder.append(", eventLogId=");
		builder.append(eventLogId);
		builder.append(", mallIndicator=");
		builder.append(mallIndicator);
		builder.append(", trxType=");
		builder.append(trxType);
		builder.append("]");
		return super.toString() + "||" + builder.toString();
	}
}
