package my.com.connector.ws.client.data;

import org.springframework.http.HttpMethod;

/**
 * Represents the request of the web services.
 * 
 * @author chinyeh
 *
 */
/**
 * @author chinyeh
 *
 * @param <E> the type of the request entity
 * @param <T> the type of the response entity
 */
public class WebServicesRequest<E, T> {

	private E requestEntity;
	
	private String requestUrl;
	
	private HttpMethod httpMethod;
	
	private Class<T> responseType;

	/**
	 * @param requestEntity the request entity
	 * @param responseType the type of the response entity
	 */
	public WebServicesRequest(E requestEntity, Class<T> responseType) {
		this.requestEntity = requestEntity;
		this.responseType = responseType;
	}
	
	/**
	 * @return the requestEntity
	 */
	public E getRequestEntity() {
		return requestEntity;
	}

	/**
	 * @return the requestUrl
	 */
	public String getRequestUrl() {
		return requestUrl;
	}

	/**
	 * @return the httpMethod
	 */
	public HttpMethod getHttpMethod() {
		return httpMethod;
	}

	/**
	 * @param requestEntity the requestEntity to set
	 */
	public void setRequestEntity(E requestEntity) {
		this.requestEntity = requestEntity;
	}

	/**
	 * @param requestUrl the requestUrl to set
	 */
	public void setRequestUrl(String requestUrl) {
		this.requestUrl = requestUrl;
	}

	/**
	 * @param httpMethod the httpMethod to set
	 */
	public void setHttpMethod(HttpMethod httpMethod) {
		this.httpMethod = httpMethod;
	}

	/**
	 * @return the responseType
	 */
	public Class<T> getResponseType() {
		return responseType;
	}

	/**
	 * @param responseType the responseType to set
	 */
	public void setResponseType(Class<T> responseType) {
		this.responseType = responseType;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("WebServicesRequest [httpMethod=");
		builder.append(httpMethod);
		builder.append(", requestEntity=");
		builder.append(requestEntity);
		builder.append(", requestUrl=");
		builder.append(requestUrl);
		builder.append(", responseType=");
		builder.append(responseType);
		builder.append("]");
		return builder.toString();
	}
	
}
